
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function define
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function w = CalBaseSP(ptn, n_num, target_w)

	[ptn_h ptn_w] = size(ptn);
	
	%%%%%%%%%%%%%%%
	% initial from all stable,
	%%%%%%%%%%%%%%%%
	step_num = 1000;        % divided into 1000 steps
	shift_w = eye(n_num);
	shift_w = [shift_w zeros(n_num,1)];
	step_w = (target_w-shift_w)/step_num;
	
	
	%%%%%%%%%%%%%%%%%
	% shift the plane until sp!=p
	%%%%%%%%%%%%%%%%%
	for i=1:n_num
        j=0;
        pre_r = 0;
        r = 0;
		while ((CalSP(ptn,shift_w)==ptn_w) & (j<step_num)) %& (r>=pre_r)
            shift_w(i,:) = shift_w(i,:) + step_w(i,:);
            
            pre_r = r;
            %r = CalRadiusBits(ptn,shift_w(i,:),i);
            
            j = j+1;
		end
	
        if(CalSP(ptn,shift_w)~=ptn_w) %| (r<pre_r)   %step backward
            shift_w(i,:) = shift_w(i,:) - step_w(i,:);
        elseif (j==step_num)    % this step is used for solving float point accuracy problem.
            tmp = shift_w(i,:);
            shift_w(i,:) = target_w(i,:);
            if(CalSP(ptn,shift_w)~=ptn_w)
                shift_w(i,:) = tmp;    
            end
        end
        
	end
	
	w = shift_w;
