function [bitUp, bitUn] = CalbitU(ptn)

    [ptn_h ptn_w] = size(ptn);
    
    %%%%%%%%%%%%%%%%%%%%%%
	% group pattern first.
	%%%%%%%%%%%%%%%%%%%%%%
	%distance between each pattern
	% X'*X-2X'X+X'*X
	xx = ones(ptn_w,1)*sum(ptn.*ptn);
	xy = ptn'*ptn;
	yy = sum(ptn.*ptn)'*ones(1,ptn_w);
	dist = xx -2*xy+yy;
	
	bitUp = [];
	bitUn = [];
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%decide the member of each group
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	for i=1:ptn_h  
        tUp = find(ptn(i,:) == 1);
        tUn = find(ptn(i,:) ==-1);
        
        Up = [];
        Un = [];
        %find patterns with minimum distance
        if(isempty(tUp))
            Up = [];
            Un = tUn;
        elseif(isempty(tUn))
            Up = tUp;
            Un = [];
        else
            dist(tUp,tUn);
            [dist_i dist_j] = find(dist(tUp,tUn) == min(min(dist(tUp,tUn))));
            Up = tUp(dist_i);
            Un = tUn(dist_j);
        end
        bitUp{i} = Up;
        bitUn{i} = Un;
	end
